import type * as React from 'react';
import { View } from 'react-native';
import { HiddenItemProps } from '../HeaderItems';
import type { ToggleMenuParam } from './OverflowMenuContext';
import { type PropsExtractor } from 'react-to-imperative';
type OverflowButtonDescriptors = ReadonlyArray<{
    title: string;
    onPress?: HiddenItemProps['onPress'];
    destructive?: boolean;
    disabled?: boolean;
}>;
export declare const extractOverflowButtonData: (hiddenButtons: React.ReactNode) => OverflowButtonDescriptors;
export declare const extractHiddenItemProps: PropsExtractor<HiddenItemProps>;
export type OnOverflowMenuPressParams = {
    hiddenButtons: OverflowButtonDescriptors;
    _private_toggleMenu: (params: ToggleMenuParam) => void;
    overflowButtonRef: null | View;
    cancelButtonLabel?: string;
    children: React.ReactNode;
};
export declare const overflowMenuPressHandlerActionSheet: ({ hiddenButtons, cancelButtonLabel, }: OnOverflowMenuPressParams) => void;
export declare const overflowMenuPressHandlerPopupMenu: ({ hiddenButtons, overflowButtonRef, }: OnOverflowMenuPressParams) => void;
export declare const overflowMenuPressHandlerDropdownMenu: ({ children, overflowButtonRef, _private_toggleMenu, }: OnOverflowMenuPressParams) => void;
export declare const defaultOnOverflowMenuPress: (params: OnOverflowMenuPressParams) => void;
export {};
//# sourceMappingURL=overflowMenuPressHandlers.d.ts.map