import * as React from 'react';
import { ViewProps } from 'react-native';
type Props = ViewProps & {
    inset?: boolean;
};
/**
 * A divider is a thin, lightweight separator that groups content in lists and page layouts.
 *
 * ## Usage
 * ```js
 * import * as React from 'react';
 * import { View } from 'react-native';
 * import { Divider, Text } from 'react-native-paper';
 *
 * const MyComponent = () => (
 *   <View>
 *     <Text>Apple</Text>
 *     <Divider />
 *     <Text>Orange</Text>
 *     <Divider />
 *   </View>
 * );
 *
 * ```
 */
export declare function Divider(props: Props): React.JSX.Element;
export {};
//# sourceMappingURL=Divider.d.ts.map