import * as React from 'react';
import { GestureResponderEvent, TextStyle, ViewStyle } from 'react-native';
export type Props = {
    /**
     * Title text for the `MenuItem`.
     */
    title: string;
    /**
     * Icon to display for the `MenuItem`.
     */
    icon?: React.ReactNode | undefined;
    /**
     * Whether the 'item' is disabled. A disabled 'item' is greyed out and `onPress` is not called on touch.
     */
    disabled?: boolean;
    /**
     * Function to execute on press.
     */
    onPress?: null | ((params?: GestureResponderEvent) => void) | undefined;
    /**
     * @optional
     */
    style?: ViewStyle;
    titleStyle?: TextStyle;
    /**
     * TestID used for testing purposes
     */
    testID?: string;
};
/**
 * A component to show a single list item inside a Menu.
 */
export declare function MenuItem(props: Props): React.JSX.Element;
//# sourceMappingURL=MenuItem.d.ts.map